DROP TABLE USERSETTINGS;
DROP TABLE CONTACTS;
DROP TABLE NOTES_FOLDERS;
DROP TABLE NOTES;
DROP TABLE CALENDAR_ITEMS;
DROP TABLE TASKS;
DROP TABLE EMAIL_DB_ITEMS;
DROP TABLE FOLDER_DB_ITEMS;
DROP TABLE FILTERS;
DROP TABLE CONTACT_GROUPS;
DROP TABLE CONTACT_GROUP_ITEMS;
COMMIT;

CREATE TABLE CONTACT_GROUPS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL,
	SHORT_NAME VARCHAR(100) DEFAULT '' NULL,
	DESCRIPTION VARCHAR(255) DEFAULT '' NULL
);
COMMIT;

CREATE TABLE CONTACT_GROUP_ITEMS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL,
	GROUP_ID BIGINT NOT NULL,
	CONTACT_ID BIGINT NOT NULL
);
COMMIT;

CREATE TABLE FILTERS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL,
	PORTION VARCHAR(100) DEFAULT '' NULL,
	CONDITION VARCHAR(30) DEFAULT '' NULL,
	KEYWORD VARCHAR(255) DEFAULT '' NULL,
	ACTION VARCHAR(30) DEFAULT '' NULL,
	DESTINATION VARCHAR(100) DEFAULT '' NULL
);
COMMIT;

CREATE TABLE FOLDER_DB_ITEMS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL,
	PARENT_ID BIGINT DEFAULT 0 NULL,
	FOLDER_NAME VARCHAR(100) NOT NULL,
	TYPE INTEGER DEFAULT 4 NOT NULL
);
COMMIT;

CREATE TABLE EMAIL_DB_ITEMS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL,
	FOLDER_ID BIGINT NOT NULL,
	UNIQUE_ID VARCHAR(100) NOT NULL,
	UNREAD BOOLEAN DEFAULT TRUE NULL,
	SIZE BIGINT DEFAULT 0 NULL,
	EMAIL LONGVARBINARY NULL
);
COMMIT;

CREATE TABLE TASKS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL, 
	TITLE VARCHAR(255) NOT NULL,
	DUE_DATE TIMESTAMP NOT NULL,
	PRIORITY INTEGER NOT NULL,
	FINISHED INTEGER NOT NULL,
	NOTE LONGVARCHAR NULL
);
COMMIT;

CREATE TABLE CALENDAR_ITEMS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL, 
	RECORD_DATE TIMESTAMP NOT NULL,
	REPEAT_TYPE INTEGER NOT NULL,
	CATEGORY VARCHAR(255) NOT NULL,
	DESCRIPTION LONGVARCHAR NOT NULL,
	REMINDER_DAYS INTEGER NOT NULL
);
COMMIT;

CREATE TABLE NOTES_FOLDERS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL, 
	FOLDER_NAME VARCHAR(255) NOT NULL
);
COMMIT;

CREATE TABLE NOTES ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL, 
	FOLDER_ID BIGINT DEFAULT 0 NOT NULL,
	NOTE LONGVARCHAR NULL
);
COMMIT;

CREATE TABLE USERSETTINGS ( 
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) NOT NULL, 
	KEYWORD VARCHAR(255) NOT NULL,
	VALUE VARCHAR(255) NOT NULL
);
COMMIT;

CREATE TABLE CONTACTS (
	ID BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
	USER VARCHAR(255) DEFAULT '' NULL,
	FIRST_NAME VARCHAR(100) DEFAULT '' NOT NULL,
	MIDDLE_NAME VARCHAR(100) DEFAULT '' NULL,
	LAST_NAME VARCHAR(100) DEFAULT '' NOT NULL,
	TITLE VARCHAR(50) DEFAULT '' NULL,
	SEX VARCHAR(10) DEFAULT '' NULL,
	GSM_NO_PRIMARY VARCHAR(30) DEFAULT '' NULL,
	GSM_NO_ALTERNATE VARCHAR(30) DEFAULT '' NULL,
	EMAIL_PRIMARY VARCHAR(255) DEFAULT '' NULL,
	EMAIL_ALTERNATE VARCHAR(255) DEFAULT '' NULL,
	WEB_PAGE VARCHAR(255) DEFAULT '' NULL,
	PERSONAL_NOTE LONGVARCHAR DEFAULT '' NULL,
	SPOUSE_NAME VARCHAR(255) DEFAULT '' NULL,
	NICKNAME VARCHAR(50) DEFAULT '' NULL,
	BIRTHDAY TIMESTAMP NULL,
	ANNIVERSARY TIMESTAMP NULL,
	HOME_ADDRESS LONGVARCHAR DEFAULT '' NULL,
	HOME_CITY VARCHAR(255) DEFAULT '' NULL,
	HOME_PROVINCE VARCHAR(255) DEFAULT '' NULL,
	HOME_ZIP VARCHAR(5) DEFAULT '' NULL,
	HOME_COUNTRY VARCHAR(100) DEFAULT '' NULL,
	HOME_PHONE VARCHAR(30) DEFAULT '' NULL,
	HOME_FAKS VARCHAR(30) DEFAULT '' NULL,
	WORK_COMPANY VARCHAR(100) DEFAULT '' NULL,
	WORK_JOB_TITLE VARCHAR(100) DEFAULT '' NULL,
	WORK_DEPARTMENT VARCHAR(100) DEFAULT '' NULL,
	WORK_OFFICE VARCHAR(100) DEFAULT '' NULL,
	WORK_PROFESSION VARCHAR(100) DEFAULT '' NULL,
	WORK_MANAGER_NAME VARCHAR(255) DEFAULT '' NULL,
	WORK_ASSISTANT_NAME VARCHAR(255) DEFAULT '' NULL,
	WORK_ADDRESS LONGVARCHAR DEFAULT '' NULL,
	WORK_CITY VARCHAR(255) DEFAULT '' NULL,
	WORK_PROVINCE VARCHAR(255) DEFAULT '' NULL,
	WORK_ZIP VARCHAR(5) DEFAULT '' NULL,
	WORK_COUNTRY VARCHAR(100) DEFAULT '' NULL,
	WORK_PHONE VARCHAR(30) DEFAULT '' NULL,
	WORK_FAKS VARCHAR(30) DEFAULT '' NULL
);
COMMIT;
