package org.claros.groupware.calendar.actions;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.calendar.controllers.CalendarDBController;
import org.claros.groupware.calendar.models.CalendarItem;
import org.claros.groupware.calendar.models.EventFormBean;
import org.claros.groupware.common.actions.BaseLoggedAction;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ShowEventAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
		String sEid = (String)getVariable(request, "eid");
		if (sEid != null) {
			Long id = new Long(sEid);
			CalendarItem item = CalendarDBController.getEventById(auth, id);
			EventFormBean bean = new EventFormBean();
			bean.setCategory(item.getCategory());
			bean.setDescription(item.getDescription());
			bean.setId(item.getId().toString());
			
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm");
			bean.setRecordDate(sdf.format(new Date(item.getRecordDate().getTime())));
			bean.setReminderDays(item.getReminderDays().toString());
			bean.setRepeatType(item.getRepeatType().toString());
			request.setAttribute("EventFormBean", bean);
		}
		return mapping.findForward("/event.jsp");
	}
}
