package org.claros.groupware.calendar.models;

import java.sql.Timestamp;

/**
 * 
 * @author Umut Gokbayrak
 */
public class CalendarItem implements Cloneable {
	private Long id;
	private String user;
	private Timestamp recordDate;
	private Integer repeatType;
	private String category;
	private String description;
	private Integer reminderDays;

	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) { // this shouldn't happen, since we are Cloneable
			return null;
		}
	}

	/**
	 * @return
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @return
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @return
	 */
	public Timestamp getRecordDate() {
		return recordDate;
	}

	/**
	 * @return
	 */
	public Integer getReminderDays() {
		return reminderDays;
	}

	/**
	 * @return
	 */
	public Integer getRepeatType() {
		return repeatType;
	}

	/**
	 * @return
	 */
	public String getUser() {
		return user;
	}

	/**
	 * @param string
	 */
	public void setDescription(String string) {
		description = string;
	}

	/**
	 * @param long1
	 */
	public void setId(Long long1) {
		id = long1;
	}

	/**
	 * @param timestamp
	 */
	public void setRecordDate(Timestamp timestamp) {
		recordDate = timestamp;
	}

	/**
	 * @param integer
	 */
	public void setReminderDays(Integer integer) {
		reminderDays = integer;
	}

	/**
	 * @param integer
	 */
	public void setRepeatType(Integer integer) {
		repeatType = integer;
	}

	/**
	 * @param string
	 */
	public void setUser(String string) {
		user = string;
	}

	/**
	 * @return
	 */
	public String getCategory() {
		return category;
	}

	/**
	 * @param string
	 */
	public void setCategory(String string) {
		category = string;
	}

}
