package org.claros.groupware.calendar.models;

import java.sql.Timestamp;

/**
 * @author Umut Gokbayrak
 */
public class CalendarItemWrap extends CalendarItem implements Comparable, Cloneable {
	private Timestamp occuringDate;

	/**
	 * 
	 */
	public CalendarItemWrap(CalendarItem item) {
		if (item != null) {
			this.setCategory(item.getCategory());
			this.setDescription(item.getDescription());
			this.setId(item.getId());
			this.setRecordDate(item.getRecordDate());
			this.setReminderDays(item.getReminderDays());
			this.setRepeatType(item.getRepeatType());
			this.setUser(item.getUser());
		}
	}

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object o) {
		if (o == null) {
			return -1;
		} else {
			CalendarItemWrap app = (CalendarItemWrap)o;
			Timestamp occur = app.getOccuringDate();
			if (occur.after(occuringDate)) {
				return 1;
			} else if (occur.equals(occuringDate)) {
				return 0;
			} else if (occur.before(occuringDate)) {
				return -1;
			}
		}
		return -1;
	}
	/**
	 * @return
	 */
	public Timestamp getOccuringDate() {
		return occuringDate;
	}

	/**
	 * @param timestamp
	 */
	public void setOccuringDate(Timestamp timestamp) {
		occuringDate = timestamp;
	}

}
