package org.claros.groupware.common.actions;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.claros.commons.exception.ClarosBaseException;
import org.claros.commons.mail.exception.ServerDownException;
import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.groupware.common.utility.Constants;
import org.claros.groupware.common.utility.Utility;

import com.jenkov.mrpersister.itf.IGenericDao;

/**
 * @author Umut Gokbayrak
 *
 */
public abstract class BaseClarosAction extends Action {
	public abstract ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception;
    
    /* (non-Javadoc)
     * @see org.apache.struts.action.Action#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		commonFunctions(response);

		ActionForward forward = null;
		try {
			forward = myExecute(mapping, form, request, response);
		} catch (ServerDownException e) {
			request.setAttribute("myexception", e.getMessage());
			forward = mapping.findForward("/profiling/loginStart.do");
		} catch (Exception e) {
			ClarosBaseException ce = new ClarosBaseException(e);
		    request.setAttribute("myexception", ce);
		    forward = mapping.findForward(Constants.GENERALERR);
		}
        return forward;
    }

    /**
     * Adds the response headers etc...
     * @param mapping
     * @param form
     * @param request
     * @param response
     */
	public void commonFunctions(HttpServletResponse response) {
		response.setHeader("Expires", "-1");
		response.setHeader("Pragma", "no-cache");
		response.setHeader("Cache-control", "no-cache");
		response.setContentType("text/html; charset=utf-8");
	}

	/**
	 * Searches for the variable in various places and returns it.
	 * @param request
	 * @param name
	 * @return Object
	 */
	public Object getVariable(HttpServletRequest request, String name) {
		Object obj = request.getParameter(name);
		if (obj == null) {
			obj = request.getAttribute(name);
			if (obj == null) {
			    obj = request.getSession().getAttribute(name);
			    if (obj == null) {
			        obj = getCookie(request, name);
			        if (obj == null) {
				        obj = getServlet().getServletContext().getAttribute(name);
			        }
			    }
			}
		}
		return obj;
	}

	public String getCookie(HttpServletRequest request, String name) {
		Cookie cookies[] = request.getCookies();
		Cookie cookie = null;
		if (cookies != null) {
			for (int i = 0; i < cookies.length; i++) {
				cookie = cookies[i];
				if (cookie.getName().equals(name)) {
					return cookie.getValue();
				}
			}
		}
		return null;
	}


	public ConnectionProfile getConnectionProfile(HttpServletRequest request) {
		return (ConnectionProfile)request.getSession().getAttribute("profile");
	}

	public ConnectionMetaHandler getConnectionHandler(HttpServletRequest request) {
		return (ConnectionMetaHandler)request.getSession().getAttribute("handler");
	}

	public IGenericDao getDbConnection() throws Exception {
		return Utility.getDbConnection("file");
	}

	public IGenericDao getDbConnection(String name) throws Exception {
		return Utility.getDbConnection(name);
	}
	
}
