package org.claros.groupware.common.actions;

import java.io.IOException;
import java.util.Enumeration;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Umut Gokbayrak
 */
public abstract class ClarosHttpServlet extends HttpServlet implements Servlet {

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		if (nonSafeCharsExists(request)) {
			throw new ServletException();
		}
		myGet(request, response);
	}

	/**
	 * @param request
	 * @param response
	 */
	protected abstract void myGet(HttpServletRequest request, HttpServletResponse response)  throws ServletException, IOException;

	/**
	 * @param request
	 * @return
	 */
	private boolean nonSafeCharsExists(HttpServletRequest request) {
		Enumeration enum = request.getParameterNames();
		String val = null;

		while (enum.hasMoreElements()) {
			val = (String)enum.nextElement();
			if (val.indexOf("^") >= 0 ||
				val.indexOf("[") >= 0 ||
				val.indexOf("\\") >= 0 ||
				val.indexOf("(") >= 0 ||
				val.indexOf(")") >= 0 ||
				val.indexOf("<") >= 0 ||
				val.indexOf(">") >= 0 ||
				val.indexOf(",") >= 0 ||
				val.indexOf("'") >= 0 ||
				val.indexOf("\"") >= 0 ||
				val.indexOf(";") >= 0 ||
				val.indexOf(":") >= 0 ||
				val.indexOf("{") >= 0 ||
				val.indexOf("}") >= 0 ||
				val.indexOf("%") >= 0 ||
				val.indexOf("#") >= 0 ||
				val.indexOf("!") >= 0 ||
				val.indexOf("&") >= 0 ||
				val.indexOf("-") >= 0 ||
				val.indexOf("*") >= 0 ||
				val.indexOf("+") >= 0 ||
				val.indexOf("$") >= 0) {
				return true;
			}
		}
		return false;
	}

	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		if (nonSafeCharsExists(request)) {
			throw new ServletException();
		}
		myPost(request, response);
	}

	/**
	 * @param request
	 * @param response
	 */
	protected abstract void myPost(HttpServletRequest request, HttpServletResponse response)  throws ServletException, IOException;
}
