package org.claros.groupware.common.utility;

import java.sql.Connection;

import org.apache.commons.dbcp.BasicDataSource;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.claros.commons.db.DbConfigList;

import com.jenkov.mrpersister.itf.IGenericDao;

/**
 * @author Umut Gokbayrak
 */
public class Utility {
	private static Log log = LogFactory.getLog(DbConfigList.class);

	public static IGenericDao getDbConnection() throws Exception {
		return getDbConnection("file");
	}

	public static IGenericDao getTxnDbConnection() throws Exception {
		return getDbConnection("file");
	}

	public static IGenericDao getDbConnection(String name) throws Exception {
		BasicDataSource bs = (BasicDataSource)DbConfigList.getDataSourceById(name);
		log.debug("Number active: " + bs.getNumActive());
		log.debug("Number idle: " + bs.getNumIdle());
		
		Connection con = bs.getConnection();
		return Constants.persistMan.getGenericDaoFactory().createDao(con);
	}
	
	public static IGenericDao getTxnDbConnection(String name) throws Exception {
		Connection con = DbConfigList.getDataSourceById(name).getConnection();
		con.setAutoCommit(false);
		return Constants.persistMan.getGenericDaoFactory().createDao(con);
	}
}
