package org.claros.groupware.contacts.actions;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.List;

import javax.servlet.ServletException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.claros.groupware.common.actions.ClarosHttpServlet;
import org.claros.groupware.common.filters.SessionListener;
import org.claros.groupware.contacts.controllers.ContactsController;
import org.claros.groupware.contacts.controllers.GroupsController;
import org.claros.groupware.contacts.models.Contact;
import org.claros.groupware.contacts.models.ContactGroup;

/**
 * @version 	1.0
 * @author
 */
public class AjaxLookupServlet extends ClarosHttpServlet {

	/* (non-Javadoc)
	 * @see org.claros.groupware.common.actions.ClarosHttpServlet#myGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void myGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		myPost(request, response);
	}

	/* (non-Javadoc)
	 * @see org.claros.groupware.common.actions.ClarosHttpServlet#myPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void myPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			String name = request.getParameter("name");
			String sessionId = request.getParameter("s");
			
			String username = SessionListener.getUserBySessionId(sessionId);
			List contacts = ContactsController.searchContactsByNameEmailNick(username, name, true);
			
//			response.setContentType("text/xml");
			response.setHeader("Cache-Control", "no-cache");
			
			String out = "";
			if (contacts != null) {
				Contact tmp = null;
				int size = contacts.size();
				if (size > 15) {
					size = 15;
				}
				for (int i=0;i<size;i++) {
					tmp = (Contact)contacts.get(i);
					out += tmp.getFirstName() + " " + tmp.getLastName() + " <" + tmp.getEmailPrimary() + ">";
					
					out += "~~~^^^";
				}
			}

			// also search in groups
			List groups = GroupsController.searchByLikeName(username, name);
			if (groups != null) {
				ContactGroup g = null;
				for (int i=0; i<groups.size();i++) {
					g = (ContactGroup)groups.get(i);
					out += g.getShortName() + "|||^^^";
				}
			}

			response.getWriter().write(URLEncoder.encode(out));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
