package org.claros.groupware.contacts.actions;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.servlet.Servlet;
import javax.servlet.ServletException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.contacts.controllers.ImportExportController;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ExportContactsServlet extends HttpServlet implements Servlet {

	/**
	* @see javax.servlet.http.HttpServlet#void (javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	*/
	public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		resp.setContentType("text/csv; charset=UTF-8");
		resp.setHeader ("Pragma", "public");
		resp.setHeader ("Cache-Control", "must-revalidate");
		resp.setDateHeader ("Expires",0); 
		
		resp.setHeader("Content-disposition","inline; filename=contacts.csv");

		PrintWriter out = resp.getWriter();

		AuthProfile auth = (AuthProfile)req.getSession().getAttribute("auth");
		ArrayList result = ImportExportController.exportContacts(auth);
		if (result != null) {
			for (int i=0;i<result.size();i++) {
				out.write((String)result.get(i) + "\n");
			}
		}
	}
}
