package org.claros.groupware.contacts.actions;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Locale;
import java.util.StringTokenizer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import org.claros.commons.models.AuthProfile;
import org.claros.commons.utility.Utility;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.common.error.UnableToImportException;
import org.claros.groupware.contacts.controllers.ImportExportController;
import org.claros.groupware.contacts.models.ImportContactFormBean;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ImportEndAction extends BaseLoggedAction {
	private static HashMap fields = new HashMap();

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		ImportContactFormBean bean = (ImportContactFormBean)form;
		FormFile file = bean.getImportFile();
		int success = 0;
		int fail = 0;
		ArrayList columns = new ArrayList();
		ArrayList data = new ArrayList();
		int i = 0;
		if (file != null) {
			BufferedReader br = new BufferedReader(new InputStreamReader(file.getInputStream()));
			String line = "";
			String tmp = null;
			try {
				while ((line = br.readLine()) != null) {
					try {
						line = Utility.replaceAllOccurances(line, ";;", "; ;");
						line = Utility.replaceAllOccurances(line, ";;", "; ;");
						StringTokenizer token = new StringTokenizer(line, ";");
						if (i == 0) {
							// the first line tells about what the fields stand for.
							String fieldName = null;
							while (token.hasMoreTokens()) {
								tmp = token.nextToken().toUpperCase(new Locale("en", "US"));
								fieldName = (String)fields.get(tmp);
								if (fieldName == null) {
									throw new UnableToImportException("Field " + tmp + " is an invalid column name");
								}
								columns.add(fieldName);
							}
						} else {
							// these are the data to be processed.
							ArrayList row = new ArrayList();
							while (token.hasMoreTokens()) {
								tmp = token.nextToken();
								row.add(tmp);
							}
							data.add(row);
						}
					} catch (UnableToImportException ue) {
						throw ue;
					} catch (Exception e) {
						// do nothing sier
					}
					i++;
				}
			} catch (Exception e) {
				// this file is invalid and cannot be processed.
				String err = "This file is not a valid csv file or not the format Claros expected. Please see the directions and try again.";
				request.setAttribute("err", err);
				return mapping.findForward("/import_result.jsp");
			}
		} else {
			String err = "Failed to upload file. Please try again or contact your administrator.";
			request.setAttribute("err", err);
			return mapping.findForward("/import_result.jsp");
		}
		
		AuthProfile auth = getAuthProfile(request);
		success = ImportExportController.importContacts(auth, columns, data);
		fail = i - success - 1;
		
		request.setAttribute("success", new Integer(success));
		request.setAttribute("fail", new Integer(fail));

		return mapping.findForward("/import_result.jsp");
	}

	static {
		fields.put("FIRST NAME", "FIRST_NAME");
		fields.put("MIDDLE NAME", "MIDDLE_NAME");
		fields.put("LAST NAME", "LAST_NAME");
		fields.put("FIRSTNAME", "FIRST_NAME");
		fields.put("MIDDLENAME", "MIDDLE_NAME");
		fields.put("LASTNAME", "LAST_NAME");
		fields.put("TITLE", "TITLE");
		fields.put("SEX", "SEX");
		fields.put("GSM PRIMARY", "GSM_NO_PRIMARY");
		fields.put("GSM ALTERNATE", "GSM_NO_ALTERNATE");
		fields.put("PRIMARY GSM", "GSM_NO_PRIMARY");
		fields.put("ALTERNATE GSM", "GSM_NO_ALTERNATE");
		fields.put("EMAIL PRIMARY", "EMAIL_PRIMARY");
		fields.put("EMAIL ALTERNATE", "EMAIL_ALTERNATE");
		fields.put("PRIMARY EMAIL", "EMAIL_PRIMARY");
		fields.put("ALTERNATE EMAIL", "EMAIL_ALTERNATE");
		fields.put("WEB PAGE", "WEB_PAGE");
		fields.put("URL", "WEB_PAGE");
		fields.put("WEBSITE", "WEB_PAGE");
		fields.put("WEBPAGE", "WEB_PAGE");
		fields.put("PERSONAL NOTE", "PERSONAL_NOTE");
		fields.put("NOTE", "PERSONAL_NOTE");
		fields.put("SPOUSE NAME", "SPOUSE_NAME");
		fields.put("NICKNAME", "NICKNAME");
		fields.put("NICK NAME", "NICKNAME");
		fields.put("BIRTHDAY", "BIRTHDAY");
		fields.put("ANNIVERSARY", "ANNIVERSARY");
		fields.put("HOME ADDRESS", "HOME_ADDRESS");
		fields.put("HOME CITY", "HOME_CITY");
		fields.put("HOME PROVINCE", "HOME_PROVINCE");
		fields.put("HOME ZIP", "HOME_ZIP");
		fields.put("HOME COUNTRY", "HOME_COUNTRY");
		fields.put("HOME PHONE", "HOME_PHONE");
		fields.put("HOME FAX", "HOME_FAKS");
		fields.put("COMPANY", "WORK_COMPANY");
		fields.put("JOB TITLE", "WORK_JOB_TITLE");
		fields.put("DEPARTMENT", "WORK_DEPARTMENT");
		fields.put("OFFICE", "WORK_OFFICE");
		fields.put("PROFESSION", "WORK_PROFESSION");
		fields.put("MANAGER NAME", "WORK_MANAGER_NAME");
		fields.put("ASSISTANT NAME", "WORK_ASSISTANT_NAME");
		fields.put("WORK ADDRESS", "WORK_ADDRESS");
		fields.put("WORK CITY", "WORK_CITY");
		fields.put("WORK PROVINCE", "WORK_PROVINCE");
		fields.put("WORK ZIP", "WORK_ZIP");
		fields.put("WORK COUNTRY", "WORK_COUNTRY");
		fields.put("WORK PHONE", "WORK_PHONE");
		fields.put("WORK FAX", "WORK_FAKS");
	}
}
