package org.claros.groupware.contacts.actions;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.contacts.controllers.GroupsController;
import org.claros.groupware.contacts.models.ContactGroup;
import org.claros.groupware.contacts.models.ContactGroupWrapper;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ListGroupsAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		AuthProfile auth = getAuthProfile(request);
		
		List groups = GroupsController.getGroupsByUser(auth);

		// surround it by wrapper and add the member count property.
		if (groups != null) {
			ContactGroup tmp = null;
			ArrayList myGroups = new ArrayList();
			ContactGroupWrapper wr = null;
			for (int i=0;i<groups.size();i++) {
				tmp = (ContactGroup)groups.get(i);
				wr = new ContactGroupWrapper(tmp);
				wr.setMemberCount(GroupsController.getMemberCountByGroup(auth, tmp.getId()));
				myGroups.add(wr);
			}
			request.setAttribute("groups", myGroups);
		}
		
		return mapping.findForward("/list_groups.jsp");
	}
}
