package org.claros.groupware.contacts.actions;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.util.LabelValueBean;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.contacts.controllers.ContactsController;
import org.claros.groupware.contacts.models.Contact;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.utility.UserPrefConstants;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class NewGroupAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
		
		List contacts = ContactsController.getContactsByNamePrefix(auth, "ALL");
		ArrayList contactsCmb = new ArrayList();
		if (contacts != null) {
			Contact tmp = null;

			// determine how to display the names
			String displayType = UserPrefsController.getUserSetting(auth, UserPrefConstants.displayType);
			boolean nameFirst = true;
			if (displayType != null && displayType.equals(UserPrefConstants.DISPLAY_TYPE_SURNAME_FIRST)) {
				nameFirst = false;
			}
			String fullName = null;
			for (int i=0; i<contacts.size(); i++) {
				tmp = (Contact)contacts.get(i);
				fullName = getFullName(tmp, nameFirst);
				if (fullName != null) {
					contactsCmb.add(new LabelValueBean(fullName, tmp.getId().toString()));
				}
			}
		}
		request.setAttribute("contacts", contactsCmb);
		request.setAttribute("members", new ArrayList());
		
		return mapping.findForward("/group.jsp");
	}

	private String getFullName(Contact contact, boolean nameFirst) {
		String firstName = contact.getFirstName();
		String middleName = contact.getMiddleName();
		String lastName = contact.getLastName();
/*		String email = contact.getEmailPrimary();
		
		if (email == null || email.trim().equals("")) {
			return null;
		}
*/
		String fullName = "";	
		if (nameFirst) {
			fullName = firstName + " " + lastName;
			if (middleName != null && !middleName.trim().equals("")) {
				fullName = firstName + " " + middleName + " " + lastName;
			}
		} else {
			fullName = lastName + ", " + firstName;
			if (middleName != null && !middleName.trim().equals("")) {
				fullName = lastName + ", " + firstName + " " + middleName;
			}
		}
		return fullName; // + "<" + email + ">";
	}
}
