package org.claros.groupware.contacts.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.contacts.controllers.GroupsController;
import org.claros.groupware.contacts.models.GroupFormBean;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class SaveGroupAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		GroupFormBean bean = (GroupFormBean)form;
		String id = bean.getId();
		AuthProfile auth = getAuthProfile(request);
		
		// if it is an update first we need to clear the previous record and start from scratch.
		if (id != null && !id.equals("")) {
			Long ids[] = new Long[1];
			ids[0] = new Long(id);
			GroupsController.deleteGroups(auth, ids);
		}
		GroupsController.addGroup(auth, bean.getGroupName(), bean.getMembers());
		
		return mapping.findForward("/group_result.jsp");
	}
}
