package org.claros.groupware.contacts.actions;

import java.util.List;
import java.util.Locale;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.contacts.controllers.ContactsController;
import org.claros.groupware.contacts.models.Contact;
import org.claros.groupware.contacts.models.SearchContactFormBean;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.utility.UserPrefConstants;

/**
 * @version 	1.0
 * @author
 */
public class SearchContactAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		SearchContactFormBean bean = (SearchContactFormBean)form;
		
		if (bean != null && (bean.getQuickSearch() != null || bean.getAddress() != null || bean.getCompany() != null || bean.getCompany() != null || bean.getEmail() != null || bean.getName() != null || bean.getPhone() != null)) {
			Locale enLoc = new Locale("en", "US");

			String address = null;
			String company = null;
			String email = null;
			String name = null;
			String phone = null;
			
			if (bean.getQuickSearch() != null) {
				String qs = bean.getQuickSearch().toUpperCase(enLoc);
				address = qs;
				company = qs;
				email = qs;
				name = qs;
				phone = qs;
			} else {
				address = bean.getAddress().toUpperCase(enLoc);
				company = bean.getCompany().toUpperCase(enLoc);
				email = bean.getEmail().toUpperCase(enLoc);
				name = bean.getName().toUpperCase(enLoc);
				phone = bean.getPhone();
			}

			AuthProfile auth = getAuthProfile(request);

			// determine how to display the fullnames		
			String displayType = UserPrefsController.getUserSetting(auth, UserPrefConstants.displayType);
			boolean nameFirst = true;
			if (displayType != null && displayType.equals(UserPrefConstants.DISPLAY_TYPE_SURNAME_FIRST)) {
				nameFirst = false;
			}
			request.setAttribute("nameFirst", new Boolean(nameFirst));

			// search contacts
			List contacts = ContactsController.searchContacts(auth, address, company, email, name, phone);
			
			if (contacts != null) {
				Contact tmp = null;
				String fullAdr = null;
				for (int i=0;i<contacts.size();i++) {
					tmp = (Contact)contacts.get(i);

					if (nameFirst) {
						fullAdr = tmp.getFirstName();
						if (tmp.getMiddleName() != null || !tmp.getMiddleName().trim().equals("")) {
							fullAdr += " " + tmp.getMiddleName();  
						}
						fullAdr += " " + tmp.getLastName();
					} else {
						fullAdr = tmp.getLastName() + ", " + tmp.getFirstName();
						if (tmp.getMiddleName() != null || !tmp.getMiddleName().trim().equals("")) {
							fullAdr += " " + tmp.getMiddleName();  
						}
					}
					fullAdr += " <" + tmp.getEmailPrimary() + ">";
					tmp.setEmailAlternate(fullAdr);
				}
			}
			request.setAttribute("contacts", contacts);

		}
		request.setAttribute("search", new Boolean(true));

		String letters[] = {"A", "B", "C", "D", "E", "F", "G", "H", "I",
							"J", "K", "L", "M", "N", "O", "P", "Q", "R", 
							"S", "T", "U", "V", "W", "X", "Y", "Z", "0", 
							"1", "2", "3", "4", "5", "6", "7", "8", "9"};
		request.setAttribute("letters", letters);

		
		return mapping.findForward("/list_contacts.jsp");
	}
}
