package org.claros.groupware.contacts.actions;

import java.sql.Timestamp;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.exception.SystemException;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedPopupAction;
import org.claros.groupware.contacts.controllers.ContactsController;
import org.claros.groupware.contacts.models.Contact;
import org.claros.groupware.contacts.models.ContactFormBean;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.utility.UserPrefConstants;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ShowContactAction extends BaseLoggedPopupAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		ContactFormBean bean = new ContactFormBean();
		
		try {
			String sId = (String)getVariable(request, "id");
			Long id = new Long(Long.parseLong(sId));
			
			AuthProfile auth = getAuthProfile(request);
			Contact contact = ContactsController.getContactById(auth, id);

			// get the contact object. Populate it into a formbean
			Timestamp anniversary = contact.getAnniversary();
			if (anniversary != null) {
				bean.setAnniversary(anniversary.toString().substring(0,10));
			}
			Timestamp birthday = contact.getBirthDay();
			if (birthday != null) {
				bean.setBirthDay(birthday.toString().substring(0,10));
			}
			
			bean.setWorkCompany(contact.getWorkCompany());
			bean.setWorkProfession(contact.getWorkProfession());
			bean.setHomeCity(contact.getHomeCity());

			bean.setWorkAssistantName(contact.getWorkAssistantName());
			bean.setHomeZip(contact.getHomeZip());
			bean.setHomePhone(contact.getHomePhone());
			bean.setWorkCity(contact.getWorkCity());
			bean.setWorkOffice(contact.getWorkOffice());
			bean.setWorkProvince(contact.getWorkProvince());
			bean.setHomeFaks(contact.getHomeFaks());
			bean.setWorkZip(contact.getWorkZip());
			bean.setSpouseName(contact.getSpouseName());
			bean.setLastName(contact.getLastName());
			bean.setSex(contact.getSex());
			bean.setHomeCountry(contact.getHomeCountry());
			bean.setWorkFaks(contact.getWorkFaks());
			bean.setWebPage(contact.getWebPage());
			bean.setHomeAddress(contact.getHomeAddress());
			bean.setTitle(contact.getTitle());
			bean.setGsmNoPrimary(contact.getGsmNoPrimary());
			bean.setWorkCountry(contact.getWorkCountry());
			bean.setEmailPrimary(contact.getEmailPrimary());
			bean.setId(contact.getId().toString());
			bean.setHomeProvince(contact.getHomeProvince());
			bean.setMiddleName(contact.getMiddleName());
			bean.setWorkAddress(contact.getWorkAddress());
			bean.setFirstName(contact.getFirstName());
			bean.setEmailAlternative(contact.getEmailAlternate());
			bean.setPersonalNote(contact.getPersonalNote());
			bean.setGsmNoAlternative(contact.getGsmNoAlternate());
			bean.setNickName(contact.getNickName());
			bean.setWorkManagerName(contact.getWorkManagerName());
			bean.setWorkPhone(contact.getWorkPhone());
			bean.setWorkJobTitle(contact.getWorkJobTitle());
			bean.setWorkDepartment(contact.getWorkDepartment());
			request.setAttribute("ContactFormBean", bean);


			// determine how to display the fullnames		
			String displayType = UserPrefsController.getUserSetting(auth, UserPrefConstants.displayType);
			boolean nameFirst = true;
			if (displayType != null && displayType.equals(UserPrefConstants.DISPLAY_TYPE_SURNAME_FIRST)) {
				nameFirst = false;
			}
			request.setAttribute("nameFirst", new Boolean(nameFirst));
		} catch (NumberFormatException e) {
			throw new SystemException();
		}
		return mapping.findForward("/contact.jsp");
	}
}
