package org.claros.groupware.contacts.controllers;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.contacts.models.Contact;

/**
 * @author Umut Gokbayrak
 */
public class ImportExportController {
	
	public static int importContacts(AuthProfile auth, ArrayList columns, ArrayList rows) {
		Contact tmp = null;
		String col = null;
		ArrayList row = null;
		String val = null;
		int success = 0;
		for (int i=0; i<rows.size(); i++) {
			try {
				tmp = new Contact();
				row = (ArrayList)rows.get(i);
				for (int j=0; j<columns.size(); j++) {
					col = (String)columns.get(j);
					try {
						val = (String)row.get(j);
					} catch (Exception m) {
						val = " ";
					}
					
					if (col.equals("FIRST_NAME")) {
						tmp.setFirstName(val);
					} else if (col.equals("MIDDLE_NAME")) {
						tmp.setMiddleName(val);
					} else if (col.equals("LAST_NAME")) {
						tmp.setLastName(val);
					} else if (col.equals("TITLE")) {
						tmp.setTitle(val);
					} else if (col.equals("SEX")) {
						tmp.setSex(val);
					} else if (col.equals("GSM_NO_PRIMARY")) {
						tmp.setGsmNoPrimary(val);
					} else if (col.equals("GSM_NO_ALTERNATE")) {
						tmp.setGsmNoAlternate(val);
					} else if (col.equals("EMAIL_PRIMARY")) {
						tmp.setEmailPrimary(val);
					} else if (col.equals("EMAIL_ALTERNATE")) {
						tmp.setEmailAlternate(val);
					} else if (col.equals("WEB_PAGE")) {
						tmp.setWebPage(val);
					} else if (col.equals("PERSONAL_NOTE")) {
						tmp.setPersonalNote(val);
					} else if (col.equals("SPOUSE_NAME")) {
						tmp.setSpouseName(val);
					} else if (col.equals("NICKNAME")) {
						tmp.setNickName(val);
					} else if (col.equals("BIRTHDAY")) {
						if (val != null && val.equals(" ") && val.length() == 10) {
							val += " 08:00:00.000";
							try {
								tmp.setBirthDay(Timestamp.valueOf(val));
							} catch (Exception e) {}
						}
					} else if (col.equals("ANNIVERSARY")) {
						if (val != null && val.equals(" ") && val.length() == 10) {
							val += " 08:00:00.000";
							try {
								tmp.setAnniversary(Timestamp.valueOf(val));
							} catch (Exception e) {}
						}
					} else if (col.equals("HOME_ADDRESS")) {
						tmp.setHomeAddress(val);
					} else if (col.equals("HOME_CITY")) {
						tmp.setHomeCity(val);
					} else if (col.equals("HOME_PROVINCE")) {
						tmp.setHomeProvince(val);
					} else if (col.equals("HOME_ZIP")) {
						tmp.setHomeZip(val);
					} else if (col.equals("HOME_COUNTRY")) {
						tmp.setHomeCountry(val);
					} else if (col.equals("HOME_PHONE")) {
						tmp.setHomePhone(val);
					} else if (col.equals("HOME_FAKS")) {
						tmp.setHomeFaks(val);
					} else if (col.equals("WORK_COMPANY")) {
						tmp.setWorkCompany(val);
					} else if (col.equals("WORK_JOB_TITLE")) {
						tmp.setWorkJobTitle(val);
					} else if (col.equals("WORK_DEPARTMENT")) {
						tmp.setWorkDepartment(val);
					} else if (col.equals("WORK_OFFICE")) {
						tmp.setWorkOffice(val);
					} else if (col.equals("WORK_PROFESSION")) {
						tmp.setWorkProfession(val);
					} else if (col.equals("WORK_MANAGER_NAME")) {
						tmp.setWorkManagerName(val);
					} else if (col.equals("WORK_ASSISTANT_NAME")) {
						tmp.setWorkAssistantName(val);
					} else if (col.equals("WORK_ADDRESS")) {
						tmp.setWorkAddress(val);
					} else if (col.equals("WORK_CITY")) {
						tmp.setWorkCity(val);
					} else if (col.equals("WORK_PROVINCE")) {
						tmp.setWorkProvince(val);
					} else if (col.equals("WORK_ZIP")) {
						tmp.setWorkZip(val);
					} else if (col.equals("WORK_COUNTRY")) {
						tmp.setWorkCountry(val);
					} else if (col.equals("WORK_PHONE")) {
						tmp.setWorkPhone(val);
					} else if (col.equals("WORK_FAKS")) {
						tmp.setWorkFaks(val);
					}
				}
				tmp.setUser(auth.getUsername());
				ContactsController.saveContact(auth, tmp);
				success++;
			} catch (Exception e) {
				// do nothing sier
			}
		}
		return success;
	}

	public static ArrayList exportContacts(AuthProfile auth) {
		ArrayList out = new ArrayList();

		out.add("FIRST NAME;MIDDLE NAME;LAST NAME;TITLE;SEX;GSM PRIMARY;GSM ALTERNATE;" +
				"EMAIL PRIMARY;EMAIL ALTERNATE;WEB PAGE;PERSONAL NOTE;SPOUSE NAME;NICKNAME;" +
				"BIRTHDAY;ANNIVERSARY;HOME ADDRESS;HOME CITY;HOME PROVINCE;HOME ZIP;HOME COUNTRY;" +
				"HOME PHONE;HOME FAX;COMPANY;JOB TITLE;DEPARTMENT;OFFICE;PROFESSION;MANAGER NAME;" +
				"ASSISTANT NAME;WORK ADDRESS;WORK CITY;WORK PROVINCE;WORK ZIP;WORK COUNTRY;WORK PHONE;WORK FAX");
		try {
			List contacts = ContactsController.getContactsByNamePrefix(auth, "ALL");
			if (contacts != null) {
				Contact tmp = null;
				Timestamp tmpDt = null;
				for (int i=0; i<contacts.size(); i++) {
					String line = "";
					tmp = (Contact)contacts.get(i);
					line += tmp.getFirstName() + ";";
					line += tmp.getMiddleName() + ";";
					line += tmp.getLastName() + ";";
					line += tmp.getTitle() + ";";
					line += tmp.getSex() + ";";
					line += tmp.getGsmNoPrimary() + ";";
					line += tmp.getGsmNoAlternate() + ";";
					line += tmp.getEmailPrimary() + ";";
					line += tmp.getEmailAlternate() + ";";
					line += tmp.getWebPage() + ";";
					line += tmp.getPersonalNote() + ";";
					line += tmp.getSpouseName() + ";";
					line += tmp.getNickName() + ";";
					
					tmpDt = tmp.getBirthDay();
					if (tmpDt != null) {
						line += tmp.getBirthDay().toString().substring(0,10) + ";";
					} else {
						line += ";";
					}
					tmpDt = tmp.getAnniversary();
					if (tmpDt != null) {
						line += tmp.getAnniversary().toString().substring(0,10) + ";";
					} else {
						line += ";";
					}
					line += tmp.getHomeAddress() + ";";
					line += tmp.getHomeCity() + ";";
					line += tmp.getHomeProvince() + ";";
					line += tmp.getHomeZip() + ";";
					line += tmp.getHomeCountry() + ";";
					line += tmp.getHomePhone() + ";";
					line += tmp.getHomeFaks() + ";";
					line += tmp.getWorkCompany() + ";";
					line += tmp.getWorkJobTitle() + ";";
					line += tmp.getWorkDepartment() + ";";
					line += tmp.getWorkOffice() + ";";
					line += tmp.getWorkProfession() + ";";
					line += tmp.getWorkManagerName() + ";";
					line += tmp.getWorkAssistantName() + ";";
					line += tmp.getWorkAddress() + ";";
					line += tmp.getWorkCity() + ";";
					line += tmp.getWorkProvince() + ";";
					line += tmp.getWorkZip() + ";";
					line += tmp.getWorkCountry() + ";";
					line += tmp.getWorkPhone() + ";";
					line += tmp.getWorkFaks() + ";";
					out.add(line);
				}
			}
		} catch (Exception e) {
			out.add("An Error Occured.");
		}
		return out;
	}
}
