package org.claros.groupware.filters.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.filters.controllers.FilterController;
import org.claros.groupware.filters.models.FilterFormBean;
import org.claros.groupware.filters.models.Filter;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class SaveFilterAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		FilterFormBean bean = (FilterFormBean)form;
		Filter filter = new Filter();
		AuthProfile auth = getAuthProfile(request);
		
		String sId = bean.getId();
		if (sId != null && !sId.equals("")) {
			filter.setId(new Long(sId));
		}
		filter.setAction(bean.getAction());
		filter.setCondition(bean.getCondition());
		filter.setDestination(bean.getDestination());
		filter.setPortion(bean.getPortion());
		filter.setUser(auth.getUsername());
		filter.setKeyword(bean.getKeyword());
		
		FilterController.saveFilter(auth, filter);
		
		return mapping.findForward("/save_result.jsp");
	}
}
