package org.claros.groupware.filters.actions;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.exception.NoPermissionException;
import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.filters.controllers.FilterController;
import org.claros.groupware.filters.models.FilterFormBean;
import org.claros.groupware.filters.models.Filter;
import org.claros.groupware.filters.utility.Utility;
import org.claros.groupware.webmail.controllers.FolderController;
import org.claros.groupware.webmail.factory.FolderControllerFactory;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ShowFilterAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
		
		Long jid = new Long((String)getVariable(request, "jid"));
		Filter filter = FilterController.getFilterById(auth, jid);
		if (!filter.getUser().equals(auth.getUsername())) {
			throw new NoPermissionException();
		}
		FilterFormBean bean = new FilterFormBean();
		bean.setAction(filter.getAction());
		bean.setCondition(filter.getCondition());
		bean.setDestination(filter.getDestination());
		bean.setId(filter.getId().toString());
		bean.setPortion(filter.getPortion());
		bean.setKeyword(filter.getKeyword());
		
		request.setAttribute("FilterFormBean", bean);
		// get all folders.

		ConnectionMetaHandler handler = getConnectionHandler(request);
		ConnectionProfile profile = getConnectionProfile(request);

		FolderControllerFactory factory = new FolderControllerFactory(auth, profile, handler);
		FolderController foldCont = factory.getFolderController();

		List folders = foldCont.getFolders();
		request.setAttribute("folders", folders);

		Utility.prepareRequestObjects(request);

		return mapping.findForward("/filter.jsp");
	}
}
