package org.claros.groupware.notes.actions;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.notes.controllers.FolderController;
import org.claros.groupware.notes.controllers.NotesController;
import org.claros.groupware.notes.models.Note;
import org.claros.groupware.notes.models.NotesFolder;

/**
 * @version 	1.0
 * @author
 */
public class ListNotesAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
//		List folders = FolderController.getFolders(auth);
//		request.setAttribute("folders", folders);
		
		String folderId = (String)request.getParameter("fid");
		List notes = new ArrayList();
		if (folderId == null || folderId.equals("0")) {
			// unfiled notes
			notes = NotesController.getUnfiledNotes(auth);
			request.setAttribute("folderId", new Long(0));

			request.setAttribute("folderName", "Unfiled");
		} else {
			// filed notes
			notes = NotesController.getNotesByFolderId(auth, new Long(folderId));
			request.setAttribute("folderId", new Long(folderId));

			NotesFolder fold = FolderController.getFolderById(auth, new Long(folderId));
			request.setAttribute("folderName", fold.getFolderName());
		}
		if (notes != null) {
			Note note = null;
			for (int i=0;i<notes.size();i++) {
				note = (Note)notes.get(i);
				note.setNote(org.claros.commons.utility.Utility.replaceAllOccurances(note.getNote(), "\n", "<br>"));
				note.setNote(org.claros.commons.utility.Utility.replaceAllOccurances(note.getNote(), "\t", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"));
			}
		}
		request.setAttribute("notes", notes);
		
		return mapping.findForward("/list_notes.jsp");
	}
}
