package org.claros.groupware.preferences.actions;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.TimeZone;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.util.LabelValueBean;

import org.claros.commons.configuration.PropertyFile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.models.PrefFormBean;
import org.claros.groupware.preferences.utility.UserPrefConstants;

/**
 * @version 	1.0
 * @author		Umut Gokbayrak
 */
public class PrefEntryAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);

		HashMap prefMap = UserPrefsController.getUserPreferences(auth);
		request.getSession().setAttribute("prefs", prefMap);
		PrefFormBean bean = new PrefFormBean();
		bean.setFromAddress((String) prefMap.get(UserPrefConstants.fromAddress));
		bean.setFullname((String) prefMap.get(UserPrefConstants.fullName));
		bean.setReplyToAddress((String) prefMap.get(UserPrefConstants.replyToAddress));
		
		String mailFormat = (String) prefMap.get(UserPrefConstants.mailFormat);
		if (mailFormat == null) {
			mailFormat = "html";
		}
		bean.setMailFormat(mailFormat);
		bean.setSignature((String) prefMap.get(UserPrefConstants.signature));
		bean.setDisplayType((String) prefMap.get(UserPrefConstants.displayType));
		
		String spamAnal = (String)prefMap.get(UserPrefConstants.spamAnalysis);
		if (spamAnal == null) {
			spamAnal = "no";
		}
		bean.setSpamAnalysis(spamAnal);
		bean.setSpamUserAccepts((String)prefMap.get(UserPrefConstants.spamUserAccepts));

		// rss URL
		String showNews = (String) prefMap.get(UserPrefConstants.showNews);
		if (showNews == null) {
			showNews = "yes";
		}
		String newsUrl = (String) prefMap.get(UserPrefConstants.newsUrl);
		if (newsUrl == null) {
			newsUrl = "http://rss.cnn.com/rss/cnn_topstories.rss";
		}
		bean.setShowNews(showNews);
		bean.setNewsUrl(newsUrl);

		// delete fetched
		String deleteFetched = (String)prefMap.get(UserPrefConstants.deleteFetched);
		if (deleteFetched == null) {
			deleteFetched = "yes";
		}
		bean.setDeleteFetched(deleteFetched);
		
		String saveSent = (String)prefMap.get(UserPrefConstants.saveSent);
		if (saveSent == null) {
			saveSent = "yes";
		}
		bean.setSaveSent(saveSent);
		
		String sigPos = (String)prefMap.get(UserPrefConstants.signaturePos);
		if (sigPos == null) {
			sigPos = "top";
		}
		bean.setSignaturePos(sigPos);
		bean.setSafeContacts((String)prefMap.get(UserPrefConstants.safeContacts));

		String tzUser = (String) prefMap.get(UserPrefConstants.timeZone);
		if (tzUser == null) {
			String tzServer = PropertyFile.getConfiguration("/config/config.xml").getString("common-params.server-timezone");
			if (tzServer == null) {
				tzUser = "Europe/Istanbul";
			} else {
				tzUser = tzServer;
			}
		}
		bean.setTimeZone(tzUser);
		request.setAttribute("PrefFormBean", bean);

		// 12 hour 24 hour display setting
		String calendarHour = (String)prefMap.get(UserPrefConstants.calendarHour);
		if (calendarHour == null) {
			calendarHour = "12";
		}
		bean.setCalendarHour(calendarHour);

		// day starts at
		String dayStarts = (String)prefMap.get(UserPrefConstants.dayStarts);
		if (dayStarts == null) {
			dayStarts = "8";
		}
		bean.setDayStarts(dayStarts);

		String dispType = (String)prefMap.get(UserPrefConstants.displayType);
		if (dispType == null) {
			bean.setDisplayType(UserPrefConstants.DISPLAY_TYPE_NAME_FIRST);
		}

		// jsp needs to know the constants.
		UserPrefConstants consts = new UserPrefConstants();
		request.setAttribute("UserPrefConstants", consts);

		// timezones are also must be in the request scope
		String zones[] = TimeZone.getAvailableIDs();
		TimeZone tz = null;
		String zoneName, zoneId = null;
		ArrayList tzs = new ArrayList();
		for (int i = 0; i < zones.length; i++) {
			tz = TimeZone.getTimeZone(zones[i]);
			zoneName = tz.getDisplayName();
			zoneId = tz.getID();
			tzs.add(new LabelValueBean(zoneName + " (" + zoneId + ")", zoneId));
		}
		request.setAttribute("timeZones", tzs);

		

		return mapping.findForward("/preferences.jsp");
	}

}
