package org.claros.groupware.preferences.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.cache.CacheManager;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.preferences.controllers.UserPrefsController;
import org.claros.groupware.preferences.models.PrefFormBean;
import org.claros.groupware.preferences.utility.UserPrefConstants;

/**
 * @version 	1.0
 * @author		Umut Gokbayrak
 */
public class PrefSaveAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		PrefFormBean bean = (PrefFormBean)form;
		
		AuthProfile auth = getAuthProfile(request);
		UserPrefsController.saveItem(auth, UserPrefConstants.fromAddress, bean.getFromAddress());
		UserPrefsController.saveItem(auth, UserPrefConstants.fullName, bean.getFullname());
		UserPrefsController.saveItem(auth, UserPrefConstants.mailFormat, bean.getMailFormat());
		UserPrefsController.saveItem(auth, UserPrefConstants.replyToAddress, bean.getReplyToAddress());
		UserPrefsController.saveItem(auth, UserPrefConstants.signature, bean.getSignature());
		UserPrefsController.saveItem(auth, UserPrefConstants.displayType, bean.getDisplayType());
		UserPrefsController.saveItem(auth, UserPrefConstants.timeZone, bean.getTimeZone());
		UserPrefsController.saveItem(auth, UserPrefConstants.calendarHour, bean.getCalendarHour());
		UserPrefsController.saveItem(auth, UserPrefConstants.dayStarts, bean.getDayStarts());
		UserPrefsController.saveItem(auth, UserPrefConstants.spamAnalysis, bean.getSpamAnalysis());
		UserPrefsController.saveItem(auth, UserPrefConstants.spamUserAccepts, bean.getSpamUserAccepts());
		UserPrefsController.saveItem(auth, UserPrefConstants.deleteFetched, bean.getDeleteFetched());
		UserPrefsController.saveItem(auth, UserPrefConstants.saveSent, bean.getSaveSent());
		UserPrefsController.saveItem(auth, UserPrefConstants.signaturePos, bean.getSignaturePos());
		
		String safeContacts = bean.getSafeContacts();
		if (safeContacts == null) {
			safeContacts = "no";
		}
		UserPrefsController.saveItem(auth, UserPrefConstants.safeContacts, safeContacts);
		UserPrefsController.saveItem(auth, UserPrefConstants.showNews, bean.getShowNews());
		UserPrefsController.saveItem(auth, UserPrefConstants.newsUrl, bean.getNewsUrl());

		// news cache is disabled so that it can be fetched again.		
		CacheManager.invalidate(auth.getUsername() + "news");
		
		return mapping.findForward("/save_result.jsp");
	}

}
