package org.claros.groupware.profiling.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.mail.protocols.Protocol;
import org.claros.commons.mail.protocols.ProtocolFactory;
import org.claros.commons.mail.utility.Constants;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedPopupAction;

/**
 * @version 	1.0
 * @author		Umut Gokbayrak
 */
public class LogoutAction extends BaseLoggedPopupAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		ConnectionProfile profile = getConnectionProfile(request);
		if (profile.getProtocol().equals(Constants.IMAP)) {
			ConnectionMetaHandler handler = getConnectionHandler(request);
			AuthProfile auth = getAuthProfile(request);
			ProtocolFactory factory = new ProtocolFactory(profile, auth, handler);
			Protocol protocol = factory.getProtocol(null);
			protocol.disconnect();
		}
		
		request.getSession().invalidate();
		return mapping.findForward("loginStart.do");
	}
}
