package org.claros.groupware.webmail.actions;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedPopupAction;
import org.claros.groupware.webmail.controllers.InboxController;
import org.claros.groupware.webmail.factory.InboxControllerFactory;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class CheckNewMailAction extends BaseLoggedPopupAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		try {
			Long lastCheck = (Long)request.getSession().getAttribute("mBoxLastCheck");
			Date date = new Date();
			
			if (lastCheck == null) {
				request.getSession().setAttribute("mBoxLastCheck", new Long(date.getTime()));
			} else if ((lastCheck.longValue() + (5 * 60 * 1000)) < new Date().getTime()) {
				AuthProfile auth = getAuthProfile(request);
				ConnectionMetaHandler handler = getConnectionHandler(request);
				ConnectionProfile profile = getConnectionProfile(request);
				
				InboxControllerFactory factory = new InboxControllerFactory(auth, profile, handler);
				InboxController inbox = factory.getInboxController();
				
				handler = inbox.checkEmail();
				request.getSession().setAttribute("mBoxLastCheck", new Long(date.getTime()));
				request.getSession().setAttribute("handler", handler);
			}
		} catch (Exception e) {
			// just go on checking...
		}
		return mapping.findForward("/checker.jsp");
	}
}
