package org.claros.groupware.webmail.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.webmail.controllers.MailController;
import org.claros.groupware.webmail.factory.MailControllerFactory;
import org.claros.groupware.webmail.models.MailboxFormBean;

/**
 * @author Umut Gokbayrak
 */
public class DeleteMsgsAction extends BaseLoggedAction {

	/* (non-Javadoc)
	 * @see org.claros.groupware.common.actions.BaseClarosAction#myExecute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		MailboxFormBean bean = (MailboxFormBean)form;
		AuthProfile auth = getAuthProfile(request);

		int msgs[] = bean.getMsg();
		if (msgs != null) {
			ConnectionMetaHandler handler = getConnectionHandler(request);
			ConnectionProfile profile = getConnectionProfile(request);
			String folder = bean.getFid();
			
			// if delete is clicked from read message screen.
			if (folder == null) {
				folder = (String)getVariable(request, "fid");
			}
			MailControllerFactory factory = new MailControllerFactory(auth, profile, handler, folder);
			MailController mailCont = factory.getMailController();

			mailCont.deleteEmails(msgs); 
		}

		ActionForward forward = mapping.findForward("/mailbox.do");
		return forward;
	}
}
