package org.claros.groupware.webmail.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.webmail.controllers.MailController;
import org.claros.groupware.webmail.factory.MailControllerFactory;
import org.claros.groupware.webmail.models.MailboxFormBean;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class MoveMsgsAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		MailboxFormBean bean = (MailboxFormBean)form;
		AuthProfile auth = getAuthProfile(request);
		String destFolder = bean.getMoveFolder();

		int msgs[] = bean.getMsg();
		if (msgs != null) {
			ConnectionMetaHandler handler = getConnectionHandler(request);
			ConnectionProfile profile = getConnectionProfile(request);
			String folder = bean.getFid();
			MailControllerFactory factory = new MailControllerFactory(auth, profile, handler, folder);
			MailController mailCont = factory.getMailController();

			for (int i=0;i < msgs.length;i++) {
				mailCont.moveEmail(new Long("" + msgs[i]), destFolder);
			}
		}

		return mapping.findForward("/mailbox.do");
	}
}
