package org.claros.groupware.webmail.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.webmail.controllers.FolderController;
import org.claros.groupware.webmail.factory.FolderControllerFactory;
import org.claros.groupware.webmail.models.FolderDbItem;
import org.claros.groupware.webmail.models.FolderFormBean;
import org.claros.groupware.webmail.utility.Constants;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class SaveFolderAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		FolderFormBean bean = (FolderFormBean)form;
		String folderName = bean.getFolderName();
		String id = bean.getId();
		AuthProfile auth = getAuthProfile(request);

		ConnectionMetaHandler handler = getConnectionHandler(request);
		ConnectionProfile profile = getConnectionProfile(request);
			
		FolderControllerFactory factory = new FolderControllerFactory(auth, profile, handler);
		FolderController foldCont = factory.getFolderController();
		
		FolderDbItem folder = new FolderDbItem();
		boolean exists = false;
		String oldName = "";
		if (id != null && !id.equals("")) {
			// it exists before so it is a rename
			folder = foldCont.getFolder(id);
			oldName = folder.getFolderName();
			exists = true;
		} else {
			// it doesn't exist. create the folder
			folder.setType(Constants.FOLDER_TYPE_CUSTOM);
		}
		folder.setFolderName(folderName);
		folder.setUser(auth.getUsername());
		folder.setParentId(new Long(0));
		
		if (exists) {
			foldCont.renameFolder(oldName, folderName);
		} else {
			foldCont.createFolder(folder);
		}
		
		return mapping.findForward("/foldersEntry.do");
	}
}
