package org.claros.groupware.webmail.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.claros.commons.mail.models.ConnectionMetaHandler;
import org.claros.commons.mail.models.ConnectionProfile;
import org.claros.commons.mail.utility.Constants;
import org.claros.commons.models.AuthProfile;
import org.claros.groupware.common.actions.BaseLoggedAction;
import org.claros.groupware.webmail.controllers.FolderController;
import org.claros.groupware.webmail.factory.FolderControllerFactory;
import org.claros.groupware.webmail.models.FolderDbItem;
import org.claros.groupware.webmail.models.FolderFormBean;

/**
 * @version 	1.0
 * @author		Umut Gkbayrak
 */
public class ShowFolderAction extends BaseLoggedAction {

	public ActionForward myExecute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		AuthProfile auth = getAuthProfile(request);
		
		String sFolderId = (String)getVariable(request, "fid");
		if (sFolderId != null) {
			ConnectionMetaHandler handler = getConnectionHandler(request);
			ConnectionProfile profile = getConnectionProfile(request);
			
			FolderControllerFactory factory = new FolderControllerFactory(auth, profile, handler);
			FolderController foldCont = factory.getFolderController();

			FolderDbItem folder = foldCont.getFolder(sFolderId);
			
			FolderFormBean bean = new FolderFormBean();
			if (profile.getProtocol().equals(Constants.POP3)) {
				bean.setId(folder.getId().toString());
			} else {
				bean.setId(folder.getFolderName());
			}
			bean.setFolderName(folder.getFolderName());
			request.setAttribute("FolderFormBean", bean);
		}
		
		return mapping.findForward("/folder.jsp");
	}
}
