package org.claros.taglibs.page;

import java.util.Enumeration;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyTagSupport;

import org.claros.commons.utility.Utility;

/**
 * @author Umut Gokbayrak
 */
public class IndexTag extends BodyTagSupport {
	private String path;
	
	/* (non-Javadoc)
	 * @see javax.servlet.jsp.tagext.Tag#doEndTag()
	 */
	public int doEndTag() throws JspException {
		try {
			HttpServletRequest request = (HttpServletRequest)pageContext.getRequest();
			PaginatorHandler handler = (PaginatorHandler)request.getSession().getAttribute("paginator");
			
			if (handler != null) {
				String sCurrentPage = (String)pageContext.getAttribute("paginatorCurrentPage");
//				String sItemsPerPage = (String)pageContext.getAttribute("paginatorItemsPerPage");
			
//				int itemsPerPage = new Integer(sItemsPerPage).intValue();
				int currentPage = new Integer(sCurrentPage).intValue();

				/*			
				int begin = items * currentPage + 1;
				int end = items * (currentPage + 1) + 1;
				if (end > handler.getTotalItems()) {
					end = handler.getTotalItems();
				}
				*/
			
				JspWriter out = pageContext.getOut();

				/*			
				out.write("<span class=\"pagebanner\">" +
						  handler.getTotalItems() + " items found, displaying " + 
						  begin + " to " + end + ".</span>" +
						  "<span class=\"pagelinks\">" +
						  "[First" +
						  "/Prev]");
				*/

				Enumeration enum = request.getParameterNames();
				String elem = null;
				boolean hasParams = false;
				int counter = 0;
				while (enum.hasMoreElements()) {
					elem = (String)enum.nextElement();
					if (!elem.equals("p")) {
						if (counter == 0) {
							path +=  "?" + elem + "=" + request.getParameter(elem) + "&";
						} else {
							path +=  elem + "=" + request.getParameter(elem) + "&";
						}
						hasParams = true;
					}
				}
				path = Utility.extendedTrim(path, "&");

				String symbol = "?"; 
				if (hasParams) {
					symbol = "&";
				}

				int pageCount = handler.getTotalPages();

				if (pageCount > 1) {
					out.write("<strong class=\"youarehere\">Pages: </strong>");
					for (int i=0;i<pageCount;i++) {
						if (i == currentPage && i == pageCount - 1) {
							out.write("<strong>" + (i + 1) + "</strong> ");
						} else if (i == currentPage) {
							out.write("<strong>" + (i + 1) + "</strong> | ");
						} else if (i == pageCount - 1) {
							out.write("<a href=\"" + path + symbol + "p=" + i + "\">" + (i + 1) + "</a> ");
						} else {
							out.write("<a href=\"" + path + symbol + "p=" + i + "\">" + (i + 1) + "</a> | ");
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return EVAL_PAGE;
	}

	/**
	 * @return
	 */
	public String getPath() {
		return path;
	}

	/**
	 * @param string
	 */
	public void setPath(String string) {
		path = string;
	}

}
