package org.claros.taglibs.page;

import java.util.Collection;
import java.util.StringTokenizer;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.BodyTagSupport;

import org.apache.commons.beanutils.PropertyUtils;
import org.claros.commons.utility.Utility;

/**
 * @author Umut Gokbayrak
 */
public class StartTag extends BodyTagSupport {
	private String value;
	private String pageId;
	private String itemsPerPage;

	/* (non-Javadoc)
	 * @see javax.servlet.jsp.tagext.Tag#doEndTag()
	 */
	public int doEndTag() throws JspException {
		try {
			HttpServletRequest request = (HttpServletRequest)pageContext.getRequest();
			Collection col = (Collection)getBeanValue(value, request);
			String pId = (String)getBeanValue(pageId, request);
			
			PaginatorHandler handler = null;
			if (pId == null || pId.trim().equals("")) {
				handler = Paginator.paginateData(col, new Integer(itemsPerPage).intValue());
				request.getSession().setAttribute("paginator", handler);
				pId = "0";
			} else {
				handler = (PaginatorHandler)request.getSession().getAttribute("paginator");
			}
			pageContext.setAttribute("paginatorCurrentPage", pId);
			pageContext.setAttribute("paginatorItemsPerPage", itemsPerPage);
			
			String tmp = Utility.extendedTrim(value, "${");
			tmp = Utility.extendedTrim(tmp, "}");
			
			if (handler != null) {
				String handlerId = handler.getId();
				PageData tmpPage = Paginator.getPage(handlerId, new Integer(pId).intValue());
			
				if (tmpPage != null) {
					pageContext.setAttribute(tmp, tmpPage.getPageData());
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return super.doEndTag();
	}

	public Object getVariable(HttpServletRequest request, String name) {
		Object obj = request.getParameter(name);
		if (obj == null) {
			obj = request.getAttribute(name);
			if (obj == null) {
				obj = request.getSession().getAttribute(name);
				if (obj == null) {
					obj = getCookie(request, name);
					if (obj == null) {
						obj = pageContext.getServletContext().getAttribute(name);
					}
				}
			}
		}
		return obj;
	}

	public String getCookie(HttpServletRequest request, String name) {
		Cookie cookies[] = request.getCookies();
		Cookie cookie = null;
		if (cookies != null) {
			for (int i = 0; i < cookies.length; i++) {
				cookie = cookies[i];
				if (cookie.getName().equals(name)) {
					return cookie.getValue();
				}
			}
		}
		return null;
	}

	public Object getBeanValue(String bean, HttpServletRequest request) throws Exception {
		if (bean == null)
			return bean;
		int pos = -1;
		int posEnd = -1;

		String evalStr = null;
		String obj = null;
		if ((pos = bean.indexOf("${")) == 0) {
			posEnd = pos + bean.substring(pos).indexOf("}");
			evalStr = bean.substring(pos + 2, posEnd).trim();

			StringTokenizer token = new StringTokenizer(evalStr, ".");
			obj = token.nextToken();
			Object reqVar = getVariable(request, obj);

			if (reqVar == null) {
				return null;
			}

			Object attrVal = reqVar;
			if (evalStr.indexOf(".") >= 0) {
				while (token.hasMoreTokens()) {
					String attr = token.nextToken();
					attrVal = PropertyUtils.getProperty(attrVal, attr);
				}
			}
			return attrVal;
		}
		return bean;
	}

	/**
	 * @return
	 */
	public String getItemsPerPage() {
		return itemsPerPage;
	}

	/**
	 * @return
	 */
	public String getPageId() {
		return pageId;
	}

	/**
	 * @return
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param string
	 */
	public void setItemsPerPage(String string) {
		itemsPerPage = string;
	}

	/**
	 * @param string
	 */
	public void setPageId(String string) {
		pageId = string;
	}

	/**
	 * @param string
	 */
	public void setValue(String string) {
		value = string;
	}

}
